unit AddressViews;

// Copyright  1997 by Jon Shemitz, all rights reserved.
// Permission is hereby granted to freely use, modify, and
// distribute this source code PROVIDED that all six lines of
// this copyright and contact notice are included without any
// changes. Questions? Comments? Offers of work?
// mailto:jon@midnightbeach.com

// ------------------------------------------------------------

// The final demo view

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls,
  Models, FickleViews;

type
  TAddressView = class(TFickleView)
    AddressLbl: TLabel;
    EditAddress1: TEdit;
    EditAddress2: TEdit;
    EditAddress3: TEdit;
    Phone1Lbl: TLabel;
    EditPhone1: TEdit;
    Phone2Lbl: TLabel;
    EditPhone2: TEdit;
    procedure AddressChange(Sender: TObject);
  private
  protected
    procedure ReadFromModel(Model: TModel);   override;
    procedure WriteToModel(Model:  TModel);   override;
    procedure SetReadOnly(Value: boolean);    override;
  public
  end;

implementation

uses Data;

{$R *.DFM}

// IView overrides

procedure TAddressView.ReadFromModel(Model: TModel);
begin
  Assert(Model is TEmployee);

  with TEmployee(Model).Employee do
    begin
    EditAddress1.Text := Address1;
    EditAddress2.Text := Address2;
    EditAddress3.Text := Address3;
    EditPhone1.Text   := Phone1;
    EditPhone2.Text   := Phone2;
    end;
end; // TAddressView.ReadFromModel

procedure TAddressView.WriteToModel(Model:  TModel);
begin
  Assert(Model is TEmployee);

  with TEmployee(Model).Employee do
    begin
    Address1 := EditAddress1.Text;
    Address2 := EditAddress2.Text;
    Address3 := EditAddress3.Text;
    Phone1   := EditPhone1.Text;
    Phone2   := EditPhone2.Text;
    end;
end; // TAddressView.WriteToModel

procedure TAddressView.SetReadOnly(Value: boolean);
begin
  inherited;
  // This might be better implemented with a loop on Components
  // that checks "if Components[Index] is TEdit" ....
  EditAddress1.Color := ShowReadOnly_EditColors[ReadOnly];
  EditAddress2.Color := ShowReadOnly_EditColors[ReadOnly];
  EditAddress3.Color := ShowReadOnly_EditColors[ReadOnly];
  EditPhone1.Color   := ShowReadOnly_EditColors[ReadOnly];
  EditPhone2.Color   := ShowReadOnly_EditColors[ReadOnly];
end; // TAddressView.SetReadOnly

// OnChange validations

procedure TAddressView.AddressChange(Sender: TObject);
begin
  inherited;
  Valid := (Trim(EditAddress1.Text) <> '') or
           (Trim(EditAddress2.Text) <> '') or
           (Trim(EditAddress3.Text) <> '') ;
end; // TAddressView.AddressChange

end.

