unit BirthdayViews;

// Copyright  1997 by Jon Shemitz, all rights reserved.
// Permission is hereby granted to freely use, modify, and
// distribute this source code PROVIDED that all six lines of
// this copyright and contact notice are included without any
// changes. Questions? Comments? Offers of work?
// mailto:jon@midnightbeach.com

// ------------------------------------------------------------

// OK, so this is less plausible. I just wanted three pages ...

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Mask,
  Models, FickleViews;

type
  TBirthdayView = class(TFickleView)
    BirthdateLbl: TLabel;
    EditBirthdate: TMaskEdit;
    procedure EditBirthdateChange(Sender: TObject);
  private
  protected
    procedure ReadFromModel(Model: TModel);   override;
    procedure WriteToModel(Model:  TModel);   override;
    procedure SetReadOnly(Value: boolean);    override;
  public
  end;

implementation

uses Data;

{$R *.DFM}

// IView overrides

procedure TBirthdayView.ReadFromModel(Model: TModel);
begin
  Assert(Model is TEmployee);

  with TEmployee(Model) do
    begin
    EditBirthdate.Text := DateToStr(Employee.Birthdate);
    end;
end; // TBirthdayView.ReadFromModel

procedure TBirthdayView.WriteToModel(Model:  TModel);
begin
  Assert(Model is TEmployee);

  with TEmployee(Model) do
    begin
    Employee.Birthdate := StrToDate(EditBirthdate.Text);
    end;
end; // TBirthdayView.WriteToModel

procedure TBirthdayView.SetReadOnly(Value: boolean);
begin
  inherited;
  EditBirthdate.Color := ShowReadOnly_EditColors[ReadOnly];
end; // TBirthdayView.SetReadOnly

// OnChange validation

procedure TBirthdayView.EditBirthdateChange(Sender: TObject);
begin
  inherited;
  try
    StrToDate(EditBirthdate.Text);
    Valid := True;
  except on {any} Exception do Valid := False; end;
end;

end.

