unit PersonIdViews;

// Copyright  1997 by Jon Shemitz, all rights reserved.
// Permission is hereby granted to freely use, modify, and
// distribute this source code PROVIDED that all six lines of
// this copyright and contact notice are included without any
// changes. Questions? Comments? Offers of work?
// mailto:jon@midnightbeach.com

// ------------------------------------------------------------

// A simple Person view, that just shows name and taxid. The
// Employee model contains two Person models, and the
// EmployeeIdView uses two copies of the PersonIdView.

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs,
  Models, FickleViews, Data, ExtCtrls, StdCtrls;

type
  TPersonIdView = class(TFickleView)
    NameLbl: TLabel;
    TaxIdLbl: TLabel;
    EditName: TEdit;
    EditTaxID: TEdit;
    procedure EditNameChange(Sender: TObject);
  private
  protected
    procedure ReadFromModel(Model: TModel);   override;
    procedure WriteToModel(Model:  TModel);   override;
    procedure SetReadOnly(Value: boolean);    override;
  public
  end;

implementation

{$R *.DFM}

// IView overrides

procedure TPersonIdView.ReadFromModel(Model: TModel);
begin
  Assert(Model is TPerson);

  with TPerson(Model) do
    begin
    EditName.Text  := Name;
    EditTaxId.Text := TaxID;
    end; // with
end; // TPersonIdView.ReadFromModel

procedure TPersonIdView.WriteToModel(Model:  TModel);
begin
  Assert(Model is TPerson);

  with TPerson(Model) do
    begin
    Name  := EditName.Text;
    TaxID := EditTaxId.Text;
    end;
end; // TPersonIdView.WriteToModel

procedure TPersonIdView.SetReadOnly(Value: boolean);
begin
  inherited;
  EditName.Color  := ShowReadOnly_EditColors[ReadOnly];
  EditTaxID.Color := ShowReadOnly_EditColors[ReadOnly];
end; // TPersonIdView.SetReadOnly

// validation events

procedure TPersonIdView.EditNameChange(Sender: TObject);
begin
  inherited;
  Valid := Trim(EditName.Text) <> '';
end; // TPersonIdView.EditNameChange


end.

