unit main;

// Copyright  1997 by Jon Shemitz, all rights reserved.
// Permission is hereby granted to freely use, modify, and
// distribute this source code PROVIDED that all six lines of
// this copyright and contact notice are included without any
// changes. Questions? Comments? Offers of work?
// mailto:jon@midnightbeach.com

// ------------------------------------------------------------

// A simple test program.

{ $define ReadOnly}	// Tests readonly property sheets

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls,
  Models, TestWizard, TestSheet;

type
  TTestForm = class(TForm)
    CheesyBackground: TImage;
    WizardBtn: TBitBtn;
    SheetBtn: TBitBtn;
    procedure RunWizard(Sender: TObject);
    procedure RunSheet(Sender: TObject);
  private
    procedure EditModel(Editor: IModelEdit; Model: TModel);
  end;

var
  TestForm: TTestForm;

implementation

uses Data;

{$R *.DFM}

procedure TTestForm.EditModel(Editor: IModelEdit; Model: TModel);
begin
  {$ifdef ReadOnly}
    Editor.ReadOnly := True;
  {$endif} // ReadOnly
  if Editor.EditModel(Model)
    then ShowMessage('OK!')
    else ShowMessage('Abort ...');
end; // TTestForm.EditModel

procedure TTestForm.RunWizard(Sender: TObject);
var
  Employee: TEmployee;
begin
  Employee := DataModel.NewEmployee;
  try
    EditModel(TWizard.Create(Self), Employee);
  finally Employee.Free; end;
end;

procedure TTestForm.RunSheet(Sender: TObject);
var
  Employee: TEmployee;
begin
  Employee := DataModel.LoadEmployee(3);
  try
    EditModel(TPropertySheet.Create(Self), Employee);
  finally Employee.Free; end;
end;

end.

